# Gridlock - a collection of grid-based strategy games
# Copyright (c) 2009 Brian Nenninger (brian@dozingcatsoftware.com)
# Gridlock comes with ABSOLUTELY NO WARRANTY, and is released under version 3 of the GNU GPL.

from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *
import PGOpenGLUtils

import ThinkAhead

SIZE1 = 0.2
SIZE5 = 0.4
blobs = [ () ] * 16
blobs[0] = ( ((0,0,0), 0.5), )
blobs[1] = ( ((0,0,0), SIZE1), )
blobs[2] = ( ((0.4,0.4,0), SIZE1), ((-0.4,-0.4,0), SIZE1), )
blobs[3] = ( ((0,0.5,0), SIZE1), ((-0.4,-0.4,0), SIZE1), ((0.4,-0.4,0), SIZE1), )
blobs[4] = ( ((0.4,0,0), SIZE1), ((0,0.4,0), SIZE1), ((-0.4,0,0), SIZE1), ((0,-0.4,0), SIZE1), )
blobs[5] = ( ((0,0,0), SIZE5), )
blobs[6] = ( ((0,0,0), SIZE5), ((0,0.7,0), SIZE1), )
blobs[7] = ( ((0,0,0), SIZE5), ((0.6,-0.6,0), SIZE1), ((-0.6,0.6,0), SIZE1), )
blobs[8] = ( ((0,0,0), SIZE5), ((0,-0.7,0), SIZE1), ((0.6,0.7,0), SIZE1), ((-0.6,0.7,0), SIZE1), )
blobs[9] = ( ((0,0,0), SIZE5), ((0.7,0,0), SIZE1), ((-0.7,0,0), SIZE1), ((0,0.7,0), SIZE1), ((0,-0.7,0), SIZE1), )
blobs[10] = ( ((0.5,0.5,0), SIZE5), ((-0.5,-0.5,0), SIZE5), )
blobs[12] = ( ((0.5,0.5,0), SIZE5), ((-0.5,-0.5,0), SIZE5), ((-0.5,0.5,0), SIZE1), ((0.5,-0.5,0), SIZE1),)
blobs[15] = ( ((0,0.5,0), SIZE5), ((-0.5,-0.5,0), SIZE5), ((0.5,-0.5,0), SIZE5), )

POSITIVE_COLOR = [0.0,1.0,0.0]
NEGATIVE_COLOR = [1.0,0.0,0.0]
ZERO_COLOR = [0.3,0.3,0.3]

def drawCell(state, coord, value, scale):
    if value==ThinkAhead.VISITED:
        # gray cube for visited cells, white for last move
        color = [75,75,75]
        if coord==state.extra_state['last_move']: color = [255,255,255]
        glDisable(GL_DITHER)
        glDisable(GL_LIGHTING)
        glColor3ub(*color)
        # for 2d, draw half cube
        if len(coord)==2:
            glTranslatef(0, 0, scale/4)
            glScalef(1, 1, 0.5)
        glutSolidCube(scale)
        glEnable(GL_DITHER)
        glEnable(GL_LIGHTING)
    else:
        # green positive, red negative, gray zero
        color = ZERO_COLOR
        if value>0: color = POSITIVE_COLOR
        if value<0: color = NEGATIVE_COLOR
        PGOpenGLUtils.draw_blobs(coord, blobs[abs(value)], scale=scale, color=color, detail=10)
    return True
